components:
  schemas:
    User:
      type: object
      properties:
        id:
          type: string
        email:
          type: string
          format: email
        name:
          type: string
        role:
          type: string
          enum: [user, admin]
      example:
        id: 5ebac534954b54139806c112
        email: fake@example.com
        name: fake name
        role: user

    Address:
      type: object
      properties:
        addressId:
          type: string
        firstname:
          type: string
        lastname:
          type: string
        addressline1:
          type: string
        addressline2:
          type: string
        city:
          type: string
        zipcode:
          type: string
        state:
          type: string
        country:
          type: string
        countrycode:
          type: string
        phonecode:
          type: string
        phone:
          type: string
        addEmail:
          type: string
          format: email
        addType:
          type: string
      example:
          _id: 61bc9d3f8bf7db49c0056dc6
          firstname: Fake firstname
          lastname: Fake lastname
          addressline1: 59 s m lane
          addressline2:
          city: Howrah
          zipcode: "711101"
          state: west bengal
          country: india
          countrycode: IN
          phonecode: "+91"
          phone: "9876543210"
          addEmail: Fake@gmail.com
          addType: home
          primaryStatus: false

    Token:
      type: object
      properties:
        token:
          type: string
        expires:
          type: string
          format: date-time
      example:
        token: eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJzdWIiOiI1ZWJhYzUzNDk1NGI1NDEzOTgwNmMxMTIiLCJpYXQiOjE1ODkyOTg0ODQsImV4cCI6MTU4OTMwMDI4NH0.m1U63blB0MLej_WfB7yC2FTMnCziif9X8yzwDEfJXAg
        expires: 2020-05-12T16:18:04.793Z

    AuthTokens:
      type: object
      properties:
        access:
          $ref: '#/components/schemas/Token'
        refresh:
          $ref: '#/components/schemas/Token'

    Error:
      type: object
      properties:
        code:
          type: number
        message:
          type: string

    MessageType:
      type: object
      properties:
        code:
          type: number
        message:
          type: string

  responses:
    DuplicateEmail:
      description: Email already taken
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
          example:
            code: 400
            message: Email already taken
    Unauthorized:
      description: Unauthorized
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
          example:
            code: 401
            message: Please authenticate
    Forbidden:
      description: Forbidden
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
          example:
            code: 403
            message: Forbidden
    NotFound:
      description: Not found
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
          example:
            code: 404
            message: Not found

  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT

  Page:
    type: object
    properties:
        title:
          type: string
        content:
          type: array
    example:
        _id: 61bc9d3f8bf7db49c0056dc6
        title: Fake firstname
        content: [
          {
            headingOne: test,
            headingTwo: test,
            subHeading: test,
            description: test,
            buttonText: buttonText,
            buttonUrl: buttonUrl,
            imageUrl: imageUrl,
            block: [
              heading: heading,
              headingTwo: headingTwo,
              description: description,
              imageUrl: imageUrl
            ]
          }
        ]
